# $Id: circleoptions.tcl,v 1.3 1998/01/17 15:03:11 uwe Exp $
#
# evaluate cirle options
#

# option evaluation routine: setopt
source setopt.tcl

# set defaults --------------------

set state(host)		localhost
set state(pid)		[pid]
set state(whoami)	"$state(host),$state(pid)"
set state(canvas)	.c

proc evalOptions args {
    global state

    # communication options
    setopt server	$state(host)
    setopt port		4242
    setopt trace	2

    # geometry options
    setopt width	200
    setopt height	$width
    setopt radius	10
    setopt fill		red

    # options for random walk
    setopt step		[expr $radius * 4]
    setopt delay	50

    # store options in state array
    set state(server)	$server
    set state(port)	$port
    set state(trace)	$trace

    set state(width)	$width
    set state(height)	$height
    set state(radius)	$radius
    set state(fill)	$fill

    # auxiliary coordinates and parameters
    set state(leftborder)	[expr 0 - $state(radius)]
    set state(rightborder)	[expr $state(width) + $state(radius)]
    set state(upperborder)	[expr 0 - $state(radius)]
    set state(lowerborder)	[expr $state(height) + $state(radius)]

    # random walk options
    set state(delay)	$delay
    set state(step)	$step
    set state(stepmin)	[expr 0 - $state(step)]
    set state(stepmax)	[expr $state(step) + 1]
    set state(choose)	[list choose $state(stepmin) $state(stepmax)]

    if {"$args" != ""} {
	message 2 "evalOptions: options not processed: $args"
    }
}

eval evalOptions $argv


