# $Id: clientsocket.tcl,v 1.2 1996/08/26 16:09:42 uwe Exp $
#
# routines for socket i/o on the client side

proc openSocket {} {
    global state

    
    if [catch {set state(socket) [socket $state(server) $state(port)]} err] {
	message 1 "can't open socket on $state(server), port $state(port): $err"
	terminate
	return
    }
    fileevent $state(socket) readable "readSocket"

    return
}

proc closeSocket {} {
    global state
    catch {flush $state(socket)}
    catch {close $state(socket)}
}

proc writeSocket line {
    global state

    message 3 "writeSocket:	$line"

    if {[catch \
	     {
		 puts $state(socket) $line
		 flush $state(socket)
	     } err ]} {
	message 1 "writeSocket: error $err"
	terminate
    }
}

proc readSocket {} {
    global state

    set line [gets $state(socket)]

    if {"$line" == ""} {
	message 1 "readSocket:	server died"
	terminate
	return
    }

    message 3 "readSocket:	$line"
    uplevel \#0 $line
}


