#!/bin/sh
# $Id: mouse.tcl,v 1.2 1996/08/26 18:41:50 uwe Exp $
# the next line restarts using wish (must be wish4.0 or newer) \
exec wish "$0" "$@"

# message output routine: message
source message.tcl

# graphics routines: initCanvas, createCircle, moveCicle, .....
source circle.tcl

# socket i/o: openSocket, readSocket, ....
source clientsocket.tcl

# options evaluation: evalOptions
source circleoptions.tcl

# specific bindings for this application --------------------

proc moveCircleOn {x y} {
    global state

    writeSocket "moveCircle	$state(whoami) $x $y"
    writeSocket "configCircle	$state(whoami) -width 3 -outline black"

    bind $state(canvas) <Motion>	"writeSocket	\"moveCircle $state(whoami) %x %y\""
    bind $state(canvas) <Leave>		"writeSocket	bell"
    bind $state(canvas) <1>		"moveCircleOff"
}

proc moveCircleOff {} {
    global state

    writeSocket	"configCircle	$state(whoami) -width 0 -outline $state(fill)"
    bind $state(canvas) <Motion>	""
    bind $state(canvas) <Leave>	""
    bind $state(canvas) <1>		"moveCircleOn %x %y"
}

proc unbind {} {
    global state

    bind $state(canvas) <Motion>	""
    bind $state(canvas) <Leave>	""
    bind $state(canvas) <1>		""
}

# initialization and finalisation --------------------

proc init {} {
    global state

    initCanvas

    openSocket
    writeSocket "createCircle	$state(whoami) $state(fill)"

    moveCircleOff
    bind . <Control-q>	"finish"
    bind . <Destroy>	"finish"
}


proc terminate {} {
    message 2 "terminate application: close socket and unbind events"
    closeSocket
    unbind
}

proc finish {} {
    global state

    writeSocket "deleteCircle	$state(whoami)"
    terminate

    message 2 "exit"
    exit
}

init

