#!/bin/sh
# $Id: walk.tcl,v 1.3 1996/08/26 18:41:50 uwe Exp $
# the next line restarts using wish (must be wish4.0 or newer) \
exec wish "$0" "$@"

# message output routine: message
source message.tcl

# graphics routines: initCanvas, createCircle, moveCicle, .....
source circle.tcl

# socket i/o: openSocket, readSocket, ....
source clientsocket.tcl

# options evaluation: evalOptions
source circleoptions.tcl

# random generator: random [seed], choose min max
source random.tcl

# specific bindings for this application --------------------

proc walk {} {
    global state

    if $state(walk) {
	set x $state($state(whoami),x)
	set y $state($state(whoami),y)

	incr x [eval $state(choose)]
	incr y [eval $state(choose)]

	if {$x <  $state(leftborder)}	{incr x  $state(rightborder)}
	if {$x >= $state(rightborder)}	{incr x -$state(rightborder)}
	if {$y <  $state(upperborder)}	{incr y  $state(lowerborder)}
	if {$y >= $state(lowerborder)}	{incr y -$state(lowerborder)}

	writeSocket "moveCircle	$state(whoami) $x $y"

	after $state(delay) walk
    }
}

proc randomWalkOn {} {
    global state

    set state(walk) 1
    bind $state(canvas) <1>		"randomWalkOff"

    after 0 walk
}

proc randomWalkOff {} {
    global state

    set state(walk)	0
    bind $state(canvas) <1>		"randomWalkOn"
}

proc unbind {} {
    global state

    bind $state(canvas) <Motion>	""
    bind $state(canvas) <Leave>	""
    bind $state(canvas) <1>		""
}

# initialization and finalisation --------------------

proc init {} {
    global state

    initCanvas

    openSocket
    writeSocket "createCircle	$state(whoami) $state(fill)"

    randomWalkOff

    bind . <Control-q>	"finish"
    bind . <Destroy>	"finish"
}


proc terminate {} {
    message 2 "terminate application: close socket and unbind events"
    closeSocket
    unbind
}

proc finish {} {
    global state

    writeSocket "deleteCircle	$state(whoami)"

    terminate

    message 2 "exit"
    exit
}

init

